/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.205 Revision 1.237
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.205 2005/10/07 15:31:46 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.237 2006/06/04 15:18:12 vapier Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6# 4#
7# This eclass is for general purpose functions that most ebuilds 5# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves. 6# have to implement themselves.
9# 7#
10# NB: If you add anything, please comment it! 8# NB: If you add anything, please comment it!
11 9
12inherit multilib portability 10inherit multilib portability
13 11
14DEPEND="!bootstrap? ( sys-devel/patch )" 12DEPEND="!bootstrap? ( sys-devel/patch )"
13RDEPEND=""
15# sys-apps/shadow is needed for useradd, etc, bug #94745. 14# sys-apps/shadow is needed for useradd, etc, bug #94745.
16 15
17DESCRIPTION="Based on the ${ECLASS} eclass" 16DESCRIPTION="Based on the ${ECLASS} eclass"
18 17
19# Wait for the supplied number of seconds. If no argument is supplied, defaults 18# Wait for the supplied number of seconds. If no argument is supplied, defaults
60# to point to the latest version of the library present. 59# to point to the latest version of the library present.
61# 60#
62# <azarah@gentoo.org> (26 Oct 2002) 61# <azarah@gentoo.org> (26 Oct 2002)
63# 62#
64gen_usr_ldscript() { 63gen_usr_ldscript() {
65 local libdir="$(get_libdir)" 64 local lib libdir=$(get_libdir)
66 # Just make sure it exists 65 # Just make sure it exists
67 dodir /usr/${libdir} 66 dodir /usr/${libdir}
68 67
69 for lib in "${@}" ; do 68 for lib in "${@}" ; do
70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 69 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT
76 75
77 See bug http://bugs.gentoo.org/4411 for more info. 76 See bug http://bugs.gentoo.org/4411 for more info.
78 */ 77 */
79 GROUP ( /${libdir}/${lib} ) 78 GROUP ( /${libdir}/${lib} )
80 END_LDSCRIPT 79 END_LDSCRIPT
81 fperms a+x "/usr/${libdir}/${lib}" 80 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}"
82 done 81 done
83} 82}
84 83
85# Simple function to draw a line consisting of '=' the same length as $*
86# - only to be used by epatch()
87#
88# <azarah@gentoo.org> (11 Nov 2002)
89#
90draw_line() {
91 local i=0
92 local str_length=""
93
94 # Handle calls that do not have args, or wc not being installed ...
95 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
96 then
97 echo "==============================================================="
98 return 0
99 fi
100
101 # Get the length of $*
102 str_length="$(echo -n "$*" | wc -m)"
103
104 while [ "$i" -lt "${str_length}" ]
105 do
106 echo -n "="
107
108 i=$((i + 1))
109 done
110
111 echo
112
113 return 0
114}
115 84
116# Default directory where patches are located 85# Default directory where patches are located
117EPATCH_SOURCE="${WORKDIR}/patch" 86EPATCH_SOURCE="${WORKDIR}/patch"
118# Default extension for patches 87# Default extension for patches
119EPATCH_SUFFIX="patch.bz2" 88EPATCH_SUFFIX="patch.bz2"
120# Default options for patch 89# Default options for patch
121# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 90# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571
122# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 91# Set --no-backup-if-mismatch so we don't leave '.orig' files behind.
92# Set -E to automatically remove empty files.
123EPATCH_OPTS="-g0 --no-backup-if-mismatch" 93EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
124# List of patches not to apply. Not this is only file names, 94# List of patches not to apply. Not this is only file names,
125# and not the full path .. 95# and not the full path ..
126EPATCH_EXCLUDE="" 96EPATCH_EXCLUDE=""
127# Change the printed message for a single patch. 97# Change the printed message for a single patch.
128EPATCH_SINGLE_MSG="" 98EPATCH_SINGLE_MSG=""
166# hand its a directory, it will set EPATCH_SOURCE to this. 136# hand its a directory, it will set EPATCH_SOURCE to this.
167# 137#
168# <azarah@gentoo.org> (10 Nov 2002) 138# <azarah@gentoo.org> (10 Nov 2002)
169# 139#
170epatch() { 140epatch() {
141 _epatch_draw_line() {
142 [[ -z $1 ]] && set "$(printf "%65s" '')"
143 echo "${1//?/=}"
144 }
145 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
171 local PIPE_CMD="" 146 local PIPE_CMD=""
172 local STDERR_TARGET="${T}/$$.out" 147 local STDERR_TARGET="${T}/$$.out"
173 local PATCH_TARGET="${T}/$$.patch" 148 local PATCH_TARGET="${T}/$$.patch"
174 local PATCH_SUFFIX="" 149 local PATCH_SUFFIX=""
175 local SINGLE_PATCH="no" 150 local SINGLE_PATCH="no"
284 259
285 # Allow for prefix to differ ... im lazy, so shoot me :/ 260 # Allow for prefix to differ ... im lazy, so shoot me :/
286 while [ "${count}" -lt 5 ] 261 while [ "${count}" -lt 5 ]
287 do 262 do
288 # Generate some useful debug info ... 263 # Generate some useful debug info ...
289 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 264 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
290 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 265 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
291 266
292 if [ "${PATCH_SUFFIX}" != "patch" ] 267 if [ "${PATCH_SUFFIX}" != "patch" ]
293 then 268 then
294 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 269 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
299 274
300 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 275 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
301 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 276 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
302 277
303 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 278 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
304 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 279 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
305 280
306 if [ "${PATCH_SUFFIX}" != "patch" ] 281 if [ "${PATCH_SUFFIX}" != "patch" ]
307 then 282 then
308 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 283 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
309 then 284 then
313 count=5 288 count=5
314 break 289 break
315 fi 290 fi
316 fi 291 fi
317 292
318 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 293 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
319 then 294 then
320 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 295 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
321 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 296 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
322 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 297 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
323 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 298 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
324 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 299 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
325 300
326 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1 301 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
302 _epatch_assert
327 303
328 if [ "$?" -ne 0 ] 304 if [ "$?" -ne 0 ]
329 then 305 then
330 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 306 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
331 echo 307 echo
394 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 370 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
395 done 371 done
396 ${exe} "${tmp}" || ${exe} -p "${tmp}" 372 ${exe} "${tmp}" || ${exe} -p "${tmp}"
397 echo "${tmp}" 373 echo "${tmp}"
398 else 374 else
399 [[ ${exe} == "touch" ]] \ 375 if [[ ${exe} == "touch" ]] ; then
400 && exe="-p" \ 376 [[ ${USERLAND} == "GNU" ]] \
401 || exe="-d" 377 && mktemp -p "${topdir}" \
402 mktemp ${exe} "${topdir}" 378 || TMPDIR="${topdir}" mktemp -t tmp
379 else
380 [[ ${USERLAND} == "GNU" ]] \
381 && mktemp -d "${topdir}" \
382 || TMPDIR="${topdir}" mktemp -dt tmp
383 fi
403 fi 384 fi
404} 385}
405 386
406# Small wrapper for getent (Linux), nidump (Mac OS X), 387# Small wrapper for getent (Linux), nidump (Mac OS X),
407# and pw (FreeBSD) used in enewuser()/enewgroup() 388# and pw (FreeBSD) used in enewuser()/enewgroup()
419 *) # Numeric 400 *) # Numeric
420 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 401 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
421 ;; 402 ;;
422 esac 403 esac
423 ;; 404 ;;
424 *-freebsd*) 405 *-freebsd*|*-dragonfly*)
425 local opts action="user" 406 local opts action="user"
426 [[ $1 == "passwd" ]] || action="group" 407 [[ $1 == "passwd" ]] || action="group"
427 408
428 # lookup by uid/gid 409 # lookup by uid/gid
429 if [[ $2 == [[:digit:]]* ]] ; then 410 if [[ $2 == [[:digit:]]* ]] ; then
430 [[ ${action} == "user" ]] && opts="-u" || opts="-g" 411 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
431 fi 412 fi
432 413
433 pw show ${action} ${opts} "$2" -q 414 pw show ${action} ${opts} "$2" -q
415 ;;
416 *-netbsd*|*-openbsd*)
417 grep "$2:\*:" /etc/$1
434 ;; 418 ;;
435 *) 419 *)
436 type -p nscd >& /dev/null && nscd -i "$1" 420 type -p nscd >& /dev/null && nscd -i "$1"
437 getent "$1" "$2" 421 getent "$1" "$2"
438 ;; 422 ;;
451# shell: /bin/false 435# shell: /bin/false
452# homedir: /dev/null 436# homedir: /dev/null
453# groups: none 437# groups: none
454# extra: comment of 'added by portage for ${PN}' 438# extra: comment of 'added by portage for ${PN}'
455enewuser() { 439enewuser() {
440 case ${EBUILD_PHASE} in
441 unpack|compile|test|install)
442 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
443 eerror "Package fails at QA and at life. Please file a bug."
444 die "Bad package! enewuser is only for use in pkg_* functions!"
445 esac
446
456 # get the username 447 # get the username
457 local euser=$1; shift 448 local euser=$1; shift
458 if [[ -z ${euser} ]] ; then 449 if [[ -z ${euser} ]] ; then
459 eerror "No username specified !" 450 eerror "No username specified !"
460 die "Cannot call enewuser without a username" 451 die "Cannot call enewuser without a username"
492 einfo " - Userid: ${euid}" 483 einfo " - Userid: ${euid}"
493 484
494 # handle shell 485 # handle shell
495 local eshell=$1; shift 486 local eshell=$1; shift
496 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then 487 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
497 if [[ ! -e ${eshell} ]] ; then 488 if [[ ! -e ${ROOT}${eshell} ]] ; then
498 eerror "A shell was specified but it does not exist !" 489 eerror "A shell was specified but it does not exist !"
499 die "${eshell} does not exist" 490 die "${eshell} does not exist in ${ROOT}"
491 fi
492 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
493 eerror "Do not specify ${eshell} yourself, use -1"
494 die "Pass '-1' as the shell parameter"
500 fi 495 fi
501 else 496 else
502 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do 497 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
503 [[ -x ${ROOT}${shell} ]] && break 498 [[ -x ${ROOT}${shell} ]] && break
504 done 499 done
575 einfo "Please report the ebuild along with the info below" 570 einfo "Please report the ebuild along with the info below"
576 einfo "eextra: $@" 571 einfo "eextra: $@"
577 die "Required function missing" 572 die "Required function missing"
578 fi 573 fi
579 ;; 574 ;;
580 *-freebsd*) 575 *-freebsd*|*-dragonfly*)
581 if [[ -z $@ ]] ; then 576 if [[ -z $@ ]] ; then
582 pw useradd ${euser} ${opts} \ 577 pw useradd ${euser} ${opts} \
583 -c "added by portage for ${PN}" \ 578 -c "added by portage for ${PN}" \
584 die "enewuser failed" 579 die "enewuser failed"
585 else 580 else
586 einfo " - Extra: $@" 581 einfo " - Extra: $@"
587 pw useradd ${euser} ${opts} \ 582 pw useradd ${euser} ${opts} \
588 "$@" || die "enewuser failed" 583 "$@" || die "enewuser failed"
589 fi 584 fi
590 ;; 585 ;;
586
587 *-netbsd*)
588 if [[ -z $@ ]] ; then
589 useradd ${opts} ${euser} || die "enewuser failed"
590 else
591 einfo " - Extra: $@"
592 useradd ${opts} ${euser} "$@" || die "enewuser failed"
593 fi
594 ;;
595
596 *-openbsd*)
597 if [[ -z $@ ]] ; then
598 useradd -u ${euid} -s ${eshell} \
599 -d ${ehome} -c "Added by portage for ${PN}" \
600 -g ${egroups} ${euser} || die "enewuser failed"
601 else
602 einfo " - Extra: $@"
603 useradd -u ${euid} -s ${eshell} \
604 -d ${ehome} -c "Added by portage for ${PN}" \
605 -g ${egroups} ${euser} "$@" || die "enewuser failed"
606 fi
607 ;;
608
591 *) 609 *)
592 if [[ -z $@ ]] ; then 610 if [[ -z $@ ]] ; then
593 useradd ${opts} ${euser} \ 611 useradd ${opts} ${euser} \
594 -c "added by portage for ${PN}" \ 612 -c "added by portage for ${PN}" \
595 || die "enewuser failed" 613 || die "enewuser failed"
619# Default values if you do not specify any: 637# Default values if you do not specify any:
620# groupname: REQUIRED ! 638# groupname: REQUIRED !
621# gid: next available (see groupadd(8)) 639# gid: next available (see groupadd(8))
622# extra: none 640# extra: none
623enewgroup() { 641enewgroup() {
642 case ${EBUILD_PHASE} in
643 unpack|compile|test|install)
644 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
645 eerror "Package fails at QA and at life. Please file a bug."
646 die "Bad package! enewgroup is only for use in pkg_* functions!"
647 esac
648
624 # get the group 649 # get the group
625 local egroup="$1"; shift 650 local egroup="$1"; shift
626 if [ -z "${egroup}" ] 651 if [ -z "${egroup}" ]
627 then 652 then
628 eerror "No group specified !" 653 eerror "No group specified !"
690 esac 715 esac
691 dscl . create /groups/${egroup} gid ${egid} 716 dscl . create /groups/${egroup} gid ${egid}
692 dscl . create /groups/${egroup} passwd '*' 717 dscl . create /groups/${egroup} passwd '*'
693 ;; 718 ;;
694 719
695 *-freebsd*) 720 *-freebsd*|*-dragonfly*)
696 case ${egid} in 721 case ${egid} in
697 *[!0-9]*) # Non numeric 722 *[!0-9]*) # Non numeric
698 for egid in $(seq 101 999); do 723 for egid in $(seq 101 999); do
699 [ -z "`egetent group ${egid}`" ] && break 724 [ -z "`egetent group ${egid}`" ] && break
700 done 725 done
701 esac 726 esac
702 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 727 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
703 ;; 728 ;;
729
730 *-netbsd*)
731 case ${egid} in
732 *[!0-9]*) # Non numeric
733 for egid in $(seq 101 999); do
734 [ -z "`egetent group ${egid}`" ] && break
735 done
736 esac
737 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
738 ;;
739
704 *) 740 *)
705 groupadd ${opts} ${egroup} || die "enewgroup failed" 741 groupadd ${opts} ${egroup} || die "enewgroup failed"
706 ;; 742 ;;
707 esac 743 esac
708 export SANDBOX_ON="${oldsandbox}" 744 export SANDBOX_ON="${oldsandbox}"
823 type="Network;${type}" 859 type="Network;${type}"
824 ;; 860 ;;
825 861
826 sci) 862 sci)
827 case ${catmin} in 863 case ${catmin} in
828 astro*) type=Astronomoy;; 864 astro*) type=Astronomy;;
829 bio*) type=Biology;; 865 bio*) type=Biology;;
830 calc*) type=Calculator;; 866 calc*) type=Calculator;;
831 chem*) type=Chemistry;; 867 chem*) type=Chemistry;;
832 geo*) type=Geology;; 868 geo*) type=Geology;;
833 math*) type=Math;; 869 math*) type=Math;;
853 local desktop_name="${PN}" 889 local desktop_name="${PN}"
854 else 890 else
855 local desktop_name="${PN}-${SLOT}" 891 local desktop_name="${PN}-${SLOT}"
856 fi 892 fi
857 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 893 local desktop=${T}/${exec%% *}-${desktop_name}.desktop
894# local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
858 895
859echo "[Desktop Entry] 896echo "[Desktop Entry]
860Encoding=UTF-8 897Encoding=UTF-8
861Version=0.9.2 898Version=0.9.2
862Name=${name} 899Name=${name}
863Type=Application 900Type=Application
864Comment=${DESCRIPTION} 901Comment=${DESCRIPTION}
865Exec=${exec} 902Exec=${exec}
903TryExec=${exec}
866Path=${path} 904Path=${path}
867Icon=${icon} 905Icon=${icon}
868Categories=Application;${type};" > "${desktop}" 906Categories=Application;${type};" > "${desktop}"
869 907
870 ( 908 (
985 local sizeoff_t=$2 1023 local sizeoff_t=$2
986 1024
987 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1025 [[ -z ${src} ]] && die "Could not locate source for '$1'"
988 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 1026 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
989 1027
990 local shrtsrc="`basename ${src}`" 1028 local shrtsrc=$(basename "${src}")
991 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1029 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
992 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1030 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
993 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1031 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
994 1032
995 # grab metadata for debug reasons 1033 # grab metadata for debug reasons
1059# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1097# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1060# - If the file is not specified then unpack will utilize ${A}. 1098# - If the file is not specified then unpack will utilize ${A}.
1061# - If the offset is not specified then we will attempt to extract 1099# - If the offset is not specified then we will attempt to extract
1062# the proper offset from the script itself. 1100# the proper offset from the script itself.
1063unpack_makeself() { 1101unpack_makeself() {
1102 local src_input=${1:-${A}}
1064 local src=$(find_unpackable_file "$1") 1103 local src=$(find_unpackable_file "${src_input}")
1065 local skip=$2 1104 local skip=$2
1066 local exe=$3 1105 local exe=$3
1067 1106
1068 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1107 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1069 1108
1070 local shrtsrc=$(basename "${src}") 1109 local shrtsrc=$(basename "${src}")
1071 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1110 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1072 if [ -z "${skip}" ] 1111 if [[ -z ${skip} ]] ; then
1073 then
1074 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`" 1112 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1075 local skip=0 1113 local skip=0
1076 exe=tail 1114 exe=tail
1077 case ${ver} in 1115 case ${ver} in
1078 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1116 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1079 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1117 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1091 ;; 1129 ;;
1092 2.1.3) 1130 2.1.3)
1093 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1131 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1094 let skip="skip + 1" 1132 let skip="skip + 1"
1095 ;; 1133 ;;
1096 2.1.4) 1134 2.1.4|2.1.5)
1097 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1135 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1098 skip=$(head -n ${skip} "${src}" | wc -c) 1136 skip=$(head -n ${skip} "${src}" | wc -c)
1099 exe="dd" 1137 exe="dd"
1100 ;; 1138 ;;
1101 *) 1139 *)
1220 # first we figure out how many cds we're dealing with by 1258 # first we figure out how many cds we're dealing with by
1221 # the # of files they gave us 1259 # the # of files they gave us
1222 local cdcnt=0 1260 local cdcnt=0
1223 local f= 1261 local f=
1224 for f in "$@" ; do 1262 for f in "$@" ; do
1225 cdcnt=$((cdcnt + 1)) 1263 ((++cdcnt))
1226 export CDROM_CHECK_${cdcnt}="$f" 1264 export CDROM_CHECK_${cdcnt}="$f"
1227 done 1265 done
1228 export CDROM_TOTAL_CDS=${cdcnt} 1266 export CDROM_TOTAL_CDS=${cdcnt}
1229 export CDROM_CURRENT_CD=1 1267 export CDROM_CURRENT_CD=1
1230 1268
1231 # now we see if the user gave use CD_ROOT ... 1269 # now we see if the user gave use CD_ROOT ...
1232 # if they did, let's just believe them that it's correct 1270 # if they did, let's just believe them that it's correct
1233 if [[ ! -z ${CD_ROOT} ]] ; then
1234 export CDROM_ROOT=${CD_ROOT}
1235 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1236 return
1237 fi
1238 # do the same for CD_ROOT_X
1239 if [[ ! -z ${CD_ROOT_1} ]] ; then 1271 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1240 local var= 1272 local var=
1241 cdcnt=0 1273 cdcnt=0
1242 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1274 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1243 cdcnt=$((cdcnt + 1)) 1275 ((++cdcnt))
1244 var="CD_ROOT_${cdcnt}" 1276 var="CD_ROOT_${cdcnt}"
1277 [[ -z ${!var} ]] && var="CD_ROOT"
1245 if [[ -z ${!var} ]] ; then 1278 if [[ -z ${!var} ]] ; then
1246 eerror "You must either use just the CD_ROOT" 1279 eerror "You must either use just the CD_ROOT"
1247 eerror "or specify ALL the CD_ROOT_X variables." 1280 eerror "or specify ALL the CD_ROOT_X variables."
1248 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 1281 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1249 die "could not locate CD_ROOT_${cdcnt}" 1282 die "could not locate CD_ROOT_${cdcnt}"
1250 fi 1283 fi
1251 export CDROM_ROOTS_${cdcnt}="${!var}"
1252 done 1284 done
1253 export CDROM_ROOT=${CDROM_ROOTS_1} 1285 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1254 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1286 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1287 export CDROM_SET=-1
1288 for f in ${CDROM_CHECK_1//:/ } ; do
1289 ((++CDROM_SET))
1290 [[ -e ${CD_ROOT}/${f} ]] && break
1291 done
1292 export CDROM_MATCH=${f}
1255 return 1293 return
1256 fi 1294 fi
1257 1295
1296 # User didn't help us out so lets make sure they know they can
1297 # simplify the whole process ...
1258 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1298 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1259 einfon "This ebuild will need the " 1299 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1260 if [[ -z ${CDROM_NAME} ]] ; then
1261 echo "cdrom for ${PN}."
1262 else
1263 echo "${CDROM_NAME}."
1264 fi
1265 echo 1300 echo
1266 einfo "If you do not have the CD, but have the data files" 1301 einfo "If you do not have the CD, but have the data files"
1267 einfo "mounted somewhere on your filesystem, just export" 1302 einfo "mounted somewhere on your filesystem, just export"
1268 einfo "the variable CD_ROOT so that it points to the" 1303 einfo "the variable CD_ROOT so that it points to the"
1269 einfo "directory containing the files." 1304 einfo "directory containing the files."
1273 echo 1308 echo
1274 else 1309 else
1275 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1310 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1276 cdcnt=0 1311 cdcnt=0
1277 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1312 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1278 cdcnt=$((cdcnt + 1)) 1313 ((++cdcnt))
1279 var="CDROM_NAME_${cdcnt}" 1314 var="CDROM_NAME_${cdcnt}"
1280 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}" 1315 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1281 done 1316 done
1282 echo 1317 echo
1283 einfo "If you do not have the CDs, but have the data files" 1318 einfo "If you do not have the CDs, but have the data files"
1284 einfo "mounted somewhere on your filesystem, just export" 1319 einfo "mounted somewhere on your filesystem, just export"
1285 einfo "the following variables so they point to the right place:" 1320 einfo "the following variables so they point to the right place:"
1286 einfon "" 1321 einfon ""
1287 cdcnt=0 1322 cdcnt=0
1288 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1323 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1289 cdcnt=$((cdcnt + 1)) 1324 ((++cdcnt))
1290 echo -n " CD_ROOT_${cdcnt}" 1325 echo -n " CD_ROOT_${cdcnt}"
1291 done 1326 done
1292 echo 1327 echo
1293 einfo "Or, if you have all the files in the same place, or" 1328 einfo "Or, if you have all the files in the same place, or"
1294 einfo "you only have one cdrom, you can export CD_ROOT" 1329 einfo "you only have one cdrom, you can export CD_ROOT"
1297 echo 1332 echo
1298 einfo "For example:" 1333 einfo "For example:"
1299 einfo "export CD_ROOT_1=/mnt/cdrom" 1334 einfo "export CD_ROOT_1=/mnt/cdrom"
1300 echo 1335 echo
1301 fi 1336 fi
1337
1338 export CDROM_SET=""
1302 export CDROM_CURRENT_CD=0 1339 export CDROM_CURRENT_CD=0
1303 cdrom_load_next_cd 1340 cdrom_load_next_cd
1304} 1341}
1305 1342
1306# this is only used when you need access to more than one cd. 1343# this is only used when you need access to more than one cd.
1307# when you have finished using the first cd, just call this function. 1344# when you have finished using the first cd, just call this function.
1308# when it returns, CDROM_ROOT will be pointing to the second cd. 1345# when it returns, CDROM_ROOT will be pointing to the second cd.
1309# remember, you can only go forward in the cd chain, you can't go back. 1346# remember, you can only go forward in the cd chain, you can't go back.
1310cdrom_load_next_cd() { 1347cdrom_load_next_cd() {
1311 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1))
1312 local var= 1348 local var
1313 1349 ((++CDROM_CURRENT_CD))
1314 if [[ ! -z ${CD_ROOT} ]] ; then
1315 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}"
1316 return
1317 fi
1318 1350
1319 unset CDROM_ROOT 1351 unset CDROM_ROOT
1320 var=CDROM_ROOTS_${CDROM_CURRENT_CD} 1352 var=CD_ROOT_${CDROM_CURRENT_CD}
1353 [[ -z ${!var} ]] && var="CD_ROOT"
1321 if [[ -z ${!var} ]] ; then 1354 if [[ -z ${!var} ]] ; then
1322 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1355 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1323 cdrom_locate_file_on_cd ${!var} 1356 _cdrom_locate_file_on_cd ${!var}
1324 else 1357 else
1325 export CDROM_ROOT=${!var} 1358 export CDROM_ROOT=${!var}
1326 fi 1359 fi
1327 1360
1328 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1361 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1333# all it does is try to locate a give file on a cd ... if the cd isn't 1366# all it does is try to locate a give file on a cd ... if the cd isn't
1334# found, then a message asking for the user to insert the cdrom will be 1367# found, then a message asking for the user to insert the cdrom will be
1335# displayed and we'll hang out here until: 1368# displayed and we'll hang out here until:
1336# (1) the file is found on a mounted cdrom 1369# (1) the file is found on a mounted cdrom
1337# (2) the user hits CTRL+C 1370# (2) the user hits CTRL+C
1338cdrom_locate_file_on_cd() { 1371_cdrom_locate_file_on_cd() {
1372 local mline=""
1373 local showedmsg=0
1374
1339 while [[ -z ${CDROM_ROOT} ]] ; do 1375 while [[ -z ${CDROM_ROOT} ]] ; do
1340 local dir=$(dirname "$*") 1376 local i=0
1377 local -a cdset=(${*//:/ })
1378 if [[ -n ${CDROM_SET} ]] ; then
1379 cdset=(${cdset[${CDROM_SET}]})
1380 fi
1381
1382 while [[ -n ${cdset[${i}]} ]] ; do
1383 local dir=$(dirname ${cdset[${i}]})
1341 local file=$(basename "$*") 1384 local file=$(basename ${cdset[${i}]})
1342 local mline=""
1343 local showedmsg=0
1344 1385
1345 for mline in $(mount | egrep -e '(iso|cdrom)' | awk '{print $3}') ; do 1386 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do
1346 [[ -d ${mline}/${dir} ]] || continue 1387 [[ -d ${mline}/${dir} ]] || continue
1347 [[ ! -z $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] \ 1388 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then
1348 && export CDROM_ROOT=${mline} 1389 export CDROM_ROOT=${mline}
1390 export CDROM_SET=${i}
1391 export CDROM_MATCH=${cdset[${i}]}
1392 return
1393 fi
1394 done
1395
1396 ((++i))
1349 done 1397 done
1350 1398
1351 if [[ -z ${CDROM_ROOT} ]] ; then
1352 echo 1399 echo
1353 if [[ ${showedmsg} -eq 0 ]] ; then 1400 if [[ ${showedmsg} -eq 0 ]] ; then
1354 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1401 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1355 if [[ -z ${CDROM_NAME} ]] ; then 1402 if [[ -z ${CDROM_NAME} ]] ; then
1356 einfo "Please insert the cdrom for ${PN} now !" 1403 einfo "Please insert+mount the cdrom for ${PN} now !"
1357 else
1358 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1359 fi
1360 else 1404 else
1361 if [[ -z ${CDROM_NAME_1} ]] ; then
1362 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1363 else
1364 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1365 einfo "Please insert+mount the ${!var} cdrom now !" 1405 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1366 fi
1367 fi 1406 fi
1368 showedmsg=1 1407 else
1408 if [[ -z ${CDROM_NAME_1} ]] ; then
1409 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1410 else
1411 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1412 einfo "Please insert+mount the ${!var} cdrom now !"
1413 fi
1369 fi 1414 fi
1415 showedmsg=1
1416 fi
1370 einfo "Press return to scan for the cd again" 1417 einfo "Press return to scan for the cd again"
1371 einfo "or hit CTRL+C to abort the emerge." 1418 einfo "or hit CTRL+C to abort the emerge."
1372 echo 1419 echo
1373 einfo "If you are having trouble with the detection" 1420 einfo "If you are having trouble with the detection"
1374 einfo "of your CD, it is possible that you do not have" 1421 einfo "of your CD, it is possible that you do not have"
1375 einfo "Joliet support enabled in your kernel. Please" 1422 einfo "Joliet support enabled in your kernel. Please"
1376 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1423 einfo "check that CONFIG_JOLIET is enabled in your kernel."
1377 read 1424 read || die "something is screwed with your system"
1378 fi
1379 done 1425 done
1380} 1426}
1381 1427
1382# Make sure that LINGUAS only contains languages that 1428# Make sure that LINGUAS only contains languages that
1383# a package can support 1429# a package can support
1393# directories and uses the union of the lists. 1439# directories and uses the union of the lists.
1394strip-linguas() { 1440strip-linguas() {
1395 local ls newls 1441 local ls newls
1396 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1442 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1397 local op=$1; shift 1443 local op=$1; shift
1398 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1444 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift
1399 local d f 1445 local d f
1400 for d in "$@" ; do 1446 for d in "$@" ; do
1401 if [[ ${op} == "-u" ]] ; then 1447 if [[ ${op} == "-u" ]] ; then
1402 newls=${ls} 1448 newls=${ls}
1403 else 1449 else
1404 newls="" 1450 newls=""
1405 fi 1451 fi
1406 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1452 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do
1407 if [[ ${op} == "-i" ]] ; then 1453 if [[ ${op} == "-i" ]] ; then
1408 [[ ${ls/ ${f} /} != ${ls} ]] && newls="${newls} ${f}" 1454 hasq ${f} ${ls} && newls="${newls} ${f}"
1409 else 1455 else
1410 [[ ${ls/ ${f} /} == ${ls} ]] && newls="${newls} ${f}" 1456 hasq ${f} ${ls} || newls="${newls} ${f}"
1411 fi 1457 fi
1412 done 1458 done
1413 ls=${newls} 1459 ls=${newls}
1414 done 1460 done
1415 ls=${ls//.po}
1416 else 1461 else
1417 ls=$@ 1462 ls="$@"
1418 fi 1463 fi
1419 1464
1420 ls=" ${ls} "
1421 newls="" 1465 newls=""
1422 for f in ${LINGUAS} ; do 1466 for f in ${LINGUAS} ; do
1423 if [[ ${ls/ ${f} /} != ${ls} ]] ; then 1467 if hasq ${f} ${ls} ; then
1424 newls="${newls} ${f}" 1468 newls="${newls} ${f}"
1425 else 1469 else
1426 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1470 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA"
1427 fi 1471 fi
1428 done 1472 done
1429 if [[ -z ${newls} ]] ; then
1430 export LINGUAS=""
1431 else
1432 export LINGUAS=${newls:1} 1473 export LINGUAS=${newls:1}
1433 fi
1434} 1474}
1435 1475
1436# moved from kernel.eclass since they are generally useful outside of 1476# moved from kernel.eclass since they are generally useful outside of
1437# kernel.eclass -iggy (20041002) 1477# kernel.eclass -iggy (20041002)
1438 1478
1467 1507
1468# Jeremy Huddleston <eradicator@gentoo.org>: 1508# Jeremy Huddleston <eradicator@gentoo.org>:
1469# preserve_old_lib /path/to/libblah.so.0 1509# preserve_old_lib /path/to/libblah.so.0
1470# preserve_old_lib_notify /path/to/libblah.so.0 1510# preserve_old_lib_notify /path/to/libblah.so.0
1471# 1511#
1472# These functions are useful when a lib in your package changes --soname. Such 1512# These functions are useful when a lib in your package changes --library. Such
1473# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1513# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1474# would break packages that link against it. Most people get around this 1514# would break packages that link against it. Most people get around this
1475# by using the portage SLOT mechanism, but that is not always a relevant 1515# by using the portage SLOT mechanism, but that is not always a relevant
1476# solution, so instead you can add the following to your ebuilds: 1516# solution, so instead you can add the following to your ebuilds:
1477# 1517#
1508 1548
1509 ewarn "An old version of an installed library was detected on your system." 1549 ewarn "An old version of an installed library was detected on your system."
1510 ewarn "In order to avoid breaking packages that link against it, this older version" 1550 ewarn "In order to avoid breaking packages that link against it, this older version"
1511 ewarn "is not being removed. In order to make full use of this newer version," 1551 ewarn "is not being removed. In order to make full use of this newer version,"
1512 ewarn "you will need to execute the following command:" 1552 ewarn "you will need to execute the following command:"
1513 ewarn " revdep-rebuild --soname ${SONAME}" 1553 ewarn " revdep-rebuild --library ${SONAME}"
1514 ewarn 1554 ewarn
1515 ewarn "After doing that, you can safely remove ${LIB}" 1555 ewarn "After doing that, you can safely remove ${LIB}"
1516 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1556 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild"
1517 fi 1557 fi
1518} 1558}
1531 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1571 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1532 1572
1533 local PKG=$(best_version $1) 1573 local PKG=$(best_version $1)
1534 shift 1574 shift
1535 1575
1536 local USEFILE="${ROOT}/var/db/pkg/${PKG}/USE" 1576 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1577
1578 # if the USE file doesnt exist, assume the $PKG is either
1579 # injected or package.provided
1537 [[ ! -e ${USEFILE} ]] && return 1 1580 [[ ! -e ${USEFILE} ]] && return 0
1538 1581
1539 local USE_BUILT=$(<${USEFILE}) 1582 local USE_BUILT=$(<${USEFILE})
1540 while [[ $# -gt 0 ]] ; do 1583 while [[ $# -gt 0 ]] ; do
1541 if [[ ${opt} = "-o" ]] ; then 1584 if [[ ${opt} = "-o" ]] ; then
1542 has $1 ${USE_BUILT} && return 0 1585 has $1 ${USE_BUILT} && return 0
1599 # We don't want to quote ${bin} so that people can pass complex 1642 # We don't want to quote ${bin} so that people can pass complex
1600 # things as $bin ... "./someprog --args" 1643 # things as $bin ... "./someprog --args"
1601 cat << EOF > "${tmpwrapper}" 1644 cat << EOF > "${tmpwrapper}"
1602#!/bin/sh 1645#!/bin/sh
1603cd "${chdir:-.}" 1646cd "${chdir:-.}"
1647if [ -n "${libdir}" ] ; then
1604if [ "\${LD_LIBRARY_PATH+set}" = "set" ] && [ -n "${libdir}" ] ; then 1648 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1605 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}" 1649 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1650 else
1651 export LD_LIBRARY_PATH="${libdir}"
1652 fi
1606fi 1653fi
1607exec ${bin} "\$@" 1654exec ${bin} "\$@"
1608EOF 1655EOF
1609 chmod go+rx "${tmpwrapper}" 1656 chmod go+rx "${tmpwrapper}"
1610 if [[ -n ${path} ]] ; then 1657 if [[ -n ${path} ]] ; then

Legend:
Removed from v.1.205  
changed lines
  Added in v.1.237

  ViewVC Help
Powered by ViewVC 1.1.20